# Generated by rust2rpm {{ rust2rpm_version }}
{% if rpm_bcond_check %}
%bcond_without check
{% else %}
{% if rpm_test_comments %}
{% for comment in rpm_bcond_check_comments %}
{{ comment }}
{% endfor %}
{% endif %}
%bcond_with check
{% endif %}
{% if build_rustflags_debuginfo %}

# build with reduced debuginfo to work around memory limits
%global rustflags_debuginfo {{ build_rustflags_debuginfo }}
{% endif %}

%global crate {{ crate_name }}
%global crates_source https://crates.io/api/v1/crates/%{crate}/%{version}/download#/%{crate}-%{version}.crate

Name:           {{ rpm_name }}
Version:        {{ rpm_version }}
Release:        {{ rpm_release }}
Summary:        {{ rpm_summary }}

{% if crate_license != rpm_license %}
# Upstream license specification: {{ crate_license|default("(missing)") }}
{% endif %}
License:        {{ rpm_license|default("# FIXME") }}
{% if rpm_license_comments is not none %}
{{ rpm_license_comments }}
{% endif %}
URL:            https://crates.io/crates/{{ crate_name }}
Source0:        %{crates_source}
Source1:        {{ rpm_vendor_source }}
Source2:        LICENSE.dependencies
{% for source in rpm_extra_sources %}
{% for comment_line in source.comment_lines %}
{{ comment_line }}
{% endfor %}
Source{{ source.number }}:{{ source.whitespace }}{{ source.file }}
{% endfor %}
{% if rpm_patch_file_automatic is not none %}
# Automatically generated patch to strip dependencies and normalize metadata
Patch0:         {{ rpm_patch_file_automatic }}
{% endif %}
{% if rpm_patch_file_manual is not none %}
# Manually created patch for downstream crate metadata changes
{% for comment_line in rpm_patch_file_comments %}
{{ comment_line }}
{% endfor %}
Patch1:         {{ rpm_patch_file_manual }}
{% endif %}
{% for patch in rpm_extra_patches %}
{% for comment_line in patch.comment_lines %}
{{ comment_line }}
{% endfor %}
Patch{{ patch.number }}:{{ patch.whitespace }}{{ patch.file }}
{% endfor %}
{% if conf_supported_arches %}

ExclusiveArch:  {{ conf_supported_arches }}
{% endif %}

BuildRequires:  {{ rust_packaging_dep }}
  {% for req in conf_buildrequires %}
BuildRequires:  {{ req }}
  {% endfor %}
  {% if conf_test_requires %}
%if %{with check}
  {% for req in conf_test_requires %}
BuildRequires:  {{ req }}
  {% endfor %}
%endif
  {% endif %}

%global _description %{expand:
{% if rpm_description is none %}
%{summary}.
{%- else %}
{{ rpm_description }}
{%- endif %}
}

%description %{_description}

%package     -n {{ rpm_binary_package_name }}
Summary:        %{summary}
License:        # FIXME
# LICENSE.dependencies contains a full license breakdown
{% if conf_bin_requires %}

  {% for req in conf_bin_requires %}
Requires:       {{ req }}
  {% endfor %}
{% endif %}

%description -n {{ rpm_binary_package_name }} %{_description}

%files       -n {{ rpm_binary_package_name }}
  {% if rpm_license_files|length > 0 %}
    {% for file in rpm_license_files %}
%license {{ file }}
    {% endfor %}
  {% else %}
# FIXME: no license files detected
  {% endif %}
%license LICENSE.dependencies
  {% for file in rpm_doc_files %}
%doc {{ file }}
  {% endfor %}
  {% for bin in rpm_binary_names %}
%{_bindir}/{{ bin }}
  {% endfor %}
  {% for file in rpm_extra_files %}
{{ file }}
  {% endfor %}

%prep
%autosetup -n %{crate}-%{version} -p1
{% for command in rpm_prep_pre %}
{{ command }}
{% endfor %}
%cargo_prep -V 1
cp -pav %{SOURCE2} .
{% for command in rpm_prep_post %}
{{ command }}
{% endfor %}

%build
{% for command in rpm_build_pre %}
{{ command }}
{% endfor %}
%cargo_build{{ cargo_args }}
{% for command in rpm_build_post %}
{{ command }}
{% endfor %}

%install
{% for command in rpm_install_pre %}
{{ command }}
{% endfor %}
%cargo_install{{ cargo_args }}
{% for rpm_bin_rename in rpm_bin_renames %}
{{ rpm_bin_rename }}
{% endfor %}
{% for command in rpm_install_post %}
{{ command }}
{% endfor %}

%if %{with check}
%check
{% for command in rpm_check_pre %}
{{ command }}
{% endfor %}
{% if cargo_test_commands %}
{% for command in cargo_test_commands %}
{{ command }}
{% endfor %}
{% else %}
%cargo_test{{ cargo_args }}
{% endif %}
{% for command in rpm_check_post %}
{{ command }}
{% endfor %}
%endif

%changelog
{% if use_rpmautospec %}
%autochangelog
{%- else %}
{%- if make_changelog_entry -%}

  {% include "fedora" ~ "-changelog.spec.inc" %}
{% endif %}
{% endif %}
